#!/bin/bash
MYPATH=$(cd $(dirname "$0"); pwd)
. "utils/env.shlib"
DSA=$1
LDIF=$2
TYPE=$3
STATUS=$(requireStopped "$DSA")
if [ "$STATUS" -ne 0 ] ; then
   exit "$STATUS"
fi
if [[ -z "$LDIF" ]]; then
   >&2 echo LDIF file name required
   exit 2
fi
   if [[ -z "$TYPE" ]] ; then
      TYPE="octet-stream"
   elif [[ "$TYPE" == "gzip" ]] ; then
      TYPE="x-gzip"
   elif [[ "$TYPE" == "bzip2" ]] ; then
      TYPE="x-bzip2"
   elif [[ "$TYPE" == "ldif" ]] ; then
      TYPE="octet-stream"
   else
      >&2 echo type "$TYPE" is not supported
      exit 2
   fi
ADDL="--header,Content-Type: application/$TYPE,--header,Accept: application/json,--data-binary,@$LDIF"
bash "${MYPATH}/coreZ010/post.sh" "$DSA" "" "$ADDL"
