#!/bin/bash
MYPATH=$(cd $(dirname "$0"); pwd)
cd ../../..
#
## clean up
#
cleanup() {
    local _dsa=$1
    >&2 echo "cleaning up $_dsa"
    rm -f "$_dsa".zdb.gz
    export OPT=-i
    bash dsas/delete.sh "$_dsa" delete_db_all
    export OPT=
    }
JSON=$$.json
NAME=dsa$$
HOST=$(hostname)
PORT=60000
bash "$MYPATH"/user.temp "$NAME" "$HOST" "$PORT" > "$JSON"
EXIST=$(bash dsas/create.sh "$JSON")
EXIST=$(bash dsas/exist.sh "$NAME"); STATUS=$?
if [[ "$STATUS" -ne 0 ]] ; then
    >&2 echo "DSA $NAME creation failed, tests stopped"
    exit 1
else
    >&2 echo "DSA $NAME created"
    echo "$EXIST" |
        ./jq '{ "name": .name, "status": .status, "console-port": .config.knowledge[0]."console-port" }'
fi
bash dsas/status/stop.sh "$NAME"
bash dsas/ldif/load.sh "$NAME" "${MYPATH}/user.ldif"
bash dsas/ldif/read.sh "$NAME"
>&2 echo starting $NAME
bash "${MYPATH}/../start.sh" "$NAME"
>&2 echo initing $NAME
bash "${MYPATH}/../init.sh" "$NAME"
>&2 echo stopping $NAME
bash "${MYPATH}/../stop.sh" "$NAME"
>&2 echo force starting $NAME
bash "${MYPATH}/../forcestart.sh" "$NAME"
>&2 echo force stopping $NAME
bash "${MYPATH}/../forcestop.sh" "$NAME"
cleanup "$NAME"
